unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, EditPlugAPI, EditPlugAPITypes, TB2Item, TBX,
  TB2Dock, TB2Toolbar, ImgList, TBXExtItems;

type
  TForm1 = class(TForm)
    WinPan: TPanel;
    TBXToolbar1: TTBXToolbar;
    TBXItem1: TTBXItem;
    TBImageList1: TTBImageList;
    TBXItem2: TTBXItem;
    TBXItem3: TTBXItem;
    TBXItem4: TTBXItem;
    TBXSubmenuItem1: TTBXSubmenuItem;
    TBXItem5: TTBXItem;
    TBXItem6: TTBXItem;
    TBXItem7: TTBXItem;
    TBXItem8: TTBXItem;
    TBXItem9: TTBXItem;
    TBXItem10: TTBXItem;
    TBXItem11: TTBXItem;
    TBXItem12: TTBXItem;
    TBXItem13: TTBXItem;
    TBXItem14: TTBXItem;
    TBXItem15: TTBXItem;
    TBXItem16: TTBXItem;
    TBXItem17: TTBXItem;
    TBXItem18: TTBXItem;
    TBXItem19: TTBXItem;
    TBXSubmenuItem2: TTBXSubmenuItem;
    TBXItem20: TTBXItem;
    TBXItem21: TTBXItem;
    TBXItem22: TTBXItem;
    TBXSubmenuItem3: TTBXSubmenuItem;
    TBXItem23: TTBXItem;
    TBXItem24: TTBXItem;
    TBXItem25: TTBXItem;
    TBXItem26: TTBXItem;
    TBXItem27: TTBXItem;
    TBXItem28: TTBXItem;
    TBXItem29: TTBXItem;
    TBXItem30: TTBXItem;
    TBXItem31: TTBXItem;
    ColorDialog1: TColorDialog;
    TBXItem32: TTBXItem;
    TBXItem33: TTBXItem;
    TBXItem34: TTBXItem;
    TBXItem35: TTBXItem;
    TBXSubmenuItem4: TTBXSubmenuItem;
    TBXItem36: TTBXItem;
    TBXItem37: TTBXItem;
    TBXItem38: TTBXItem;
    TBXItem39: TTBXItem;
    TBXItem40: TTBXItem;
    TBXItem41: TTBXItem;
    TBXItem42: TTBXItem;
    TBXItem43: TTBXItem;
    TBXItem44: TTBXItem;
    TBXItem45: TTBXItem;
    TBXItem46: TTBXItem;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TBXItem1Click(Sender: TObject);
    procedure TBXItem6Click(Sender: TObject);
    procedure TBXItem5Click(Sender: TObject);
    procedure TBXItem7Click(Sender: TObject);
    procedure TBXItem8Click(Sender: TObject);
    procedure TBXItem9Click(Sender: TObject);
    procedure TBXItem10Click(Sender: TObject);
    procedure TBXItem2Click(Sender: TObject);
    procedure TBXItem3Click(Sender: TObject);
    procedure TBXItem4Click(Sender: TObject);
    procedure TBXItem11Click(Sender: TObject);
    procedure TBXItem12Click(Sender: TObject);
    procedure TBXItem13Click(Sender: TObject);
    procedure TBXItem14Click(Sender: TObject);
    procedure TBXItem15Click(Sender: TObject);
    procedure TBXItem16Click(Sender: TObject);
    procedure TBXItem17Click(Sender: TObject);
    procedure TBXItem18Click(Sender: TObject);
    procedure TBXItem19Click(Sender: TObject);
    procedure TBXItem20Click(Sender: TObject);
    procedure TBXItem21Click(Sender: TObject);
    procedure TBXItem22Click(Sender: TObject);
    procedure TBXItem23Click(Sender: TObject);
    procedure TBXItem24Click(Sender: TObject);
    procedure TBXItem25Click(Sender: TObject);
    procedure TBXItem26Click(Sender: TObject);
    procedure TBXItem28Click(Sender: TObject);
    procedure TBXItem27Click(Sender: TObject);
    procedure TBXItem29Click(Sender: TObject);
    procedure TBXItem30Click(Sender: TObject);
    procedure TBXItem31Click(Sender: TObject);
    procedure TBXItem32Click(Sender: TObject);
    procedure TBXItem33Click(Sender: TObject);
    procedure TBXItem34Click(Sender: TObject);
    procedure TBXItem35Click(Sender: TObject);
    procedure TBXItem36Click(Sender: TObject);
    procedure TBXItem37Click(Sender: TObject);
    procedure TBXItem38Click(Sender: TObject);
    procedure TBXItem39Click(Sender: TObject);
    procedure TBXItem40Click(Sender: TObject);
    procedure TBXItem41Click(Sender: TObject);
    procedure TBXItem42Click(Sender: TObject);
    procedure TBXItem43Click(Sender: TObject);
    procedure TBXItem44Click(Sender: TObject);
    procedure TBXItem45Click(Sender: TObject);
    procedure TBXItem46Click(Sender: TObject);
  private
    { Private declarations }
    FirstShow: boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  gPlugId: HINST;

implementation

{$R *.DFM}

uses stringutils;

{----- EXPORTS ----------------------------------------------------------------}

procedure plgSetId(id: HINST); cdecl;
begin
  gPlugId:= id;
end; exports plgSetId;

function plgShow: HWND; cdecl;
begin
  if not assigned(form1) then begin
    form1:= tform1.create(nil);
    form1.show;
    epCreatePluginTab(gPlugId, form1.handle);
  end else begin
    form1.show;
  end;
  result:= form1.Handle;
end; exports plgShow;

procedure plgWinFree; cdecl;
begin
  if assigned(form1) then begin
    form1.Free;
    form1:=nil;
  end;
end; exports plgWinFree;

function plgGetWinHandle: HWND; cdecl;
begin
  result:=0;
  if assigned(form1) then result:= form1.Handle;
end; exports plgGetWinHandle;

{------------------------------------------------------------------------------}


procedure TForm1.FormShow(Sender: TObject);
begin
  if FirstShow = true then begin
    FirstShow := false;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FirstShow := true;
end;

procedure TForm1.TBXItem1Click(Sender: TObject);
begin
  if not epLoadPlugin('NetBrowser') then showmessage('could not load browser plugin');
end;

function Indent: string;
var
  coord: TBufCoord;
  i: integer;
begin
  result := '';
  epGetActiveEdBlockBegin(coord);
  if coord.char > 1 then begin
    for i := 1 to coord.char -1 do result := result + ' ';
  end;
end;

procedure WrapText(before, after: string);
var
  s: string;
  newstr: string;
begin
  if epGetEdCount < 1 then exit;
  s := epGetActiveEdSelTextAsString;
  newstr := before + s + after;
  epSetActiveEdSelText(pchar(newstr));
  epSetActiveEdFocus;
end;

procedure InsertText(s: string);
begin
  epSetActiveEdSelText(pchar(s));
  epSetActiveEdFocus;
end;

procedure TForm1.TBXItem6Click(Sender: TObject);
begin
  WrapText('<h1>', '</h1>');
end;

procedure TForm1.TBXItem5Click(Sender: TObject);
begin
  WrapText('<h2>', '</h2>');
end;

procedure TForm1.TBXItem7Click(Sender: TObject);
begin
  WrapText('<h3>', '</h3>');
end;

procedure TForm1.TBXItem8Click(Sender: TObject);
begin
  WrapText('<h4>', '</h4>');
end;

procedure TForm1.TBXItem9Click(Sender: TObject);
begin
  WrapText('<h5>', '</h5>');
end;

procedure TForm1.TBXItem10Click(Sender: TObject);
begin
  WrapText('<h6>', '</h6>');
end;

procedure TForm1.TBXItem2Click(Sender: TObject);
begin
  WrapText('<b>', '</b>');
end;

procedure TForm1.TBXItem3Click(Sender: TObject);
begin
  WrapText('<i>', '</i>');
end;

procedure TForm1.TBXItem4Click(Sender: TObject);
begin
  WrapText('<u>', '</u>');
end;

procedure TForm1.TBXItem11Click(Sender: TObject);
begin
  InsertText('nbsp;');
end;

procedure TForm1.TBXItem12Click(Sender: TObject);
begin
  InsertText('<br />');
end;

procedure TForm1.TBXItem13Click(Sender: TObject);
begin
  WrapText('<div>'#13#10, #13#10 + Indent + '</div>');
end;

procedure TForm1.TBXItem14Click(Sender: TObject);
begin
  WrapText('<center>'#13#10, #13#10 + Indent + '</center>');
end;

procedure TForm1.TBXItem15Click(Sender: TObject);
begin
  WrapText('<p>'#13#10, #13#10 + Indent + '</p>');
end;

procedure TForm1.TBXItem16Click(Sender: TObject);
begin
  WrapText('<ol>'#13#10 + Indent + '  <li>', '</li>'#13#10 + Indent + '</ol>');
end;

procedure TForm1.TBXItem17Click(Sender: TObject);
begin
  WrapText('<ul>'#13#10 + Indent + '  <li>', '</li>'#13#10 + Indent + '</ul>');
end;

procedure TForm1.TBXItem18Click(Sender: TObject);
begin
  WrapText('<blockquote>'#13#10, #13#10 + Indent + '</blockquote>');
end;

procedure TForm1.TBXItem19Click(Sender: TObject);
begin
  WrapText('<pre>', '</pre>');
end;

procedure TForm1.TBXItem20Click(Sender: TObject);
var before, after: string;
begin
  before := '<table>'#13#10 + Indent +
            '  <tr>'#13#10 + Indent +
            '    <td>';
  after :=  '</td>'#13#10 + Indent +
            '  </tr>'#13#10 + Indent +
            '</table>';
  WrapText(before, after);
end;

procedure TForm1.TBXItem21Click(Sender: TObject);
var before, after: string;
begin
  before := '<table>'#13#10 +
            '  <tr>'#13#10 +
            '    <td>';
  after :=  '</td>'#13#10 +
            '    <td></td>'#13#10 +
            '  </tr>'#13#10 +
            '</table>';
  WrapText(before, after);
end;

procedure TForm1.TBXItem22Click(Sender: TObject);
var before, after: string;
begin
  before := '<table>'#13#10 + Indent +
            '  <tr>'#13#10 + Indent +
            '    <td>';
  after :=  '</td>'#13#10 + Indent +
            '    <td></td>'#13#10 + Indent +
            '    <td></td>'#13#10 + Indent +
            '  </tr>'#13#10 + Indent +
            '</table>';
  WrapText(before, after);
end;

procedure TForm1.TBXItem23Click(Sender: TObject);
begin
  InsertText('&copy;');
end;

procedure TForm1.TBXItem24Click(Sender: TObject);
begin
  InsertText('&trade;');
end;

procedure TForm1.TBXItem25Click(Sender: TObject);
begin
  InsertText('&reg;');
end;

procedure TForm1.TBXItem26Click(Sender: TObject);
begin
  InsertText('&amp;');
end;

procedure TForm1.TBXItem28Click(Sender: TObject);
begin
  InsertText('&lt;');
end;

procedure TForm1.TBXItem27Click(Sender: TObject);
begin
  InsertText('&gt;');
end;

procedure TForm1.TBXItem29Click(Sender: TObject);
begin
  WrapText('<a href="">', '</a>');
end;

procedure TForm1.TBXItem30Click(Sender: TObject);
begin
  InsertText('<img src="">');
end;

function ColorToHtml(DColor: TColor): string;
var tmpRGB : TColorRef;
begin
  tmpRGB := ColorToRGB(DColor) ;
  Result:=Format('#%.2x%.2x%.2x',
                 [GetRValue(tmpRGB),
                  GetGValue(tmpRGB),
                  GetBValue(tmpRGB)]) ;
end;

procedure TForm1.TBXItem31Click(Sender: TObject);
var htmlcolor: string;
begin
  if ColorDialog1.Execute then begin
    htmlcolor := ColorToHtml(ColorDialog1.Color);
    InsertText(htmlcolor);
  end;
end;

procedure TForm1.TBXItem32Click(Sender: TObject);
begin
  WrapText('<!-- ', ' -->');
end;

procedure TForm1.TBXItem33Click(Sender: TObject);
var before, after: string;
begin
  before := '<APPLET CODE="';
  after := '" WIDTH="" HEIGHT="">'#13#10 + Indent +
            '</APPLET>';
  WrapText(before, after);
end;

procedure TForm1.TBXItem34Click(Sender: TObject);
var before, after: string;
begin
  before := '<SCRIPT LANGUAGE="JavaScript">'#13#10 + Indent +
            '<!--'#13#10 + Indent;
  after := #13#10 + Indent +
            '//-->'#13#10 + Indent +
            '</SCRIPT>';
  WrapText(before, after);
end;

procedure TForm1.TBXItem35Click(Sender: TObject);
var before, after: string;
begin
  before := '<FORM METHOD=POST ACTION="">'#13#10 + Indent;
  after :=  #13#10
            + Indent +
            '</FORM>';
  WrapText(before, after);
end;

procedure TForm1.TBXItem36Click(Sender: TObject);
begin
  WrapText('<INPUT TYPE="text" NAME="', '">');
end;

procedure TForm1.TBXItem37Click(Sender: TObject);
var before, after: string;
begin
  before := '<SELECT NAME="">'#13#10 + Indent +
            '  <OPTION VALUE="" SELECTED>';
  after :=  #13#10 + Indent +
            '  <OPTION VALUE="">'#13#10 + Indent +
            '</SELECT>';
  WrapText(before, after);

end;

procedure TForm1.TBXItem38Click(Sender: TObject);
begin
  WrapText('<INPUT TYPE="radio" NAME="', '">');
end;

procedure TForm1.TBXItem39Click(Sender: TObject);
begin
  WrapText('<INPUT TYPE="checkbox" NAME="', '">');
end;

procedure TForm1.TBXItem40Click(Sender: TObject);
begin
  WrapText('<TEXTAREA NAME="" ROWS="" COLS="">', '</TEXTAREA>');
end;

procedure TForm1.TBXItem41Click(Sender: TObject);
begin
  InsertText('<INPUT TYPE="reset">');
end;

procedure TForm1.TBXItem42Click(Sender: TObject);
begin
  InsertText('<INPUT TYPE="submit">');
end;

procedure TForm1.TBXItem43Click(Sender: TObject);
begin
  WrapText('<INPUT TYPE="password" NAME="', '">');
end;

procedure TForm1.TBXItem44Click(Sender: TObject);
begin
  WrapText('<INPUT TYPE="hidden" NAME="', '">');
end;

procedure TForm1.TBXItem45Click(Sender: TObject);
begin
  WrapText('<INPUT TYPE="image" SRC="', '">');
end;

procedure TForm1.TBXItem46Click(Sender: TObject);
begin
InsertText('<FRAMESET ROWS="," COLS=",">'#13#10+ Indent +
           '  <FRAME SRC="" NAME="">'#13#10+ Indent +
           '  <FRAME SRC="" NAME="">'#13#10+ Indent +
           '</FRAMESET>');
end;

initialization

finalization

end.
